package edu.travel.tenant.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import edu.travel.remote.feign.mode.dto.tenant.AddOrUpdateTenantDto;
import edu.travel.remote.feign.mode.dto.tenant.AssignRolesOrMenusDto;
import edu.travel.remote.feign.mode.vo.tenant.MenuTreeVo;
import edu.travel.tenant.entity.EduTenant;
import edu.travel.tenant.entity.SysMenu;
import edu.travel.tenant.entity.SysRole;

import java.util.List;
import java.util.Set;

public interface ITenantService extends IService<EduTenant> {
    public EduTenant getTenantByPhoneNumber(String tenantID);

    EduTenant addTenant(AddOrUpdateTenantDto addOrUpdateTenantDto);

    void deleteByIds(Set<Long> ids);

    void updateTenant(AddOrUpdateTenantDto addOrUpdateTenantDto);

    EduTenant getTenantById(Long id);

    List<SysMenu> getMenuList(EduTenant principal);

    List<SysRole> getRoleListByUserId(EduTenant principal);

    void assignRolesToUser(AssignRolesOrMenusDto assignRolesOrMenusDto, EduTenant principal);

    List<MenuTreeVo> getTenantPageTreeList(EduTenant principal);

    void updateRolesToUser(AssignRolesOrMenusDto assignRolesOrMenusDto, EduTenant principal);

    void enableTenantByIds(Set<Long> ids);

    void disableTenantByIds(Set<Long> ids);

    IPage<EduTenant> dictMapPage(IPage<EduTenant> page, LambdaQueryWrapper<EduTenant> queryWrapper);
}
